//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Interop.Client.MetadataProvider.MetadataProvider
{
    
    
    /// <summary>
    /// The data transfer object for Two Integers Metadata
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class TwoIntegersMetadataDto : Tecan.Sila2.ISilaTransferObject<TwoIntegersMetadata>
    {
        
        private Tecan.Sila2.IntegerDto _firstInteger;
        
        private Tecan.Sila2.IntegerDto _secondInteger;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public TwoIntegersMetadataDto()
        {
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public TwoIntegersMetadataDto(TwoIntegersMetadata inner, Tecan.Sila2.IBinaryStore store)
        {
            FirstInteger = new Tecan.Sila2.IntegerDto(inner.FirstInteger, store);
            SecondInteger = new Tecan.Sila2.IntegerDto(inner.SecondInteger, store);
        }
        
        /// <summary>
        /// The first integer
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.IntegerDto FirstInteger
        {
            get
            {
                return _firstInteger;
            }
            set
            {
                _firstInteger = value;
            }
        }
        
        /// <summary>
        /// The second integer
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.IntegerDto SecondInteger
        {
            get
            {
                return _secondInteger;
            }
            set
            {
                _secondInteger = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public TwoIntegersMetadata Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new TwoIntegersMetadata(FirstInteger.Extract(store), SecondInteger.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static TwoIntegersMetadataDto Create(TwoIntegersMetadata inner, Tecan.Sila2.IBinaryStore store)
        {
            return new TwoIntegersMetadataDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return (("" + Argument.Require(FirstInteger, "firstInteger")) 
                        + Argument.Require(SecondInteger, "secondInteger"));
        }
    }
}
